ZOJ_3329 One Person Game

来源:互联网 发布:淘宝拍卖车是真的吗 编辑:程序博客网 时间:2024/05/23 16:21
One Person Game

Time Limit: 1 Second      Memory Limit: 32768 KB      Special Judge

There is a very simple and interesting one-person game. You have 3 dice, namely Die1Die2 and Die3Die1 has K1 faces. Die2 has K2 faces. Die3 has K3 faces. All the dice are fair dice, so the probability of rolling each value, 1 to K1K2K3 is exactly 1 / K1, 1 / K2 and 1 / K3. You have a counter, and the game is played as follow:

  1. Set the counter to 0 at first.
  2. Roll the 3 dice simultaneously. If the up-facing number of Die1 is a, the up-facing number of Die2 is b and the up-facing number of Die3 is c, set the counter to 0. Otherwise, add the counter by the total value of the 3 up-facing numbers.
  3. If the counter's number is still not greater than n, go to step 2. Otherwise the game is ended.

Calculate the expectation of the number of times that you cast dice before the end of the game.

Input

There are multiple test cases. The first line of input is an integer T (0 < T <= 300) indicating the number of test cases. Then T test cases follow. Each test case is a line contains 7 non-negative integers nK1K2K3abc (0 <= n <= 500, 1 < K1K2K3 <= 6, 1 <= a <= K1, 1 <= b <= K2, 1 <= c <= K3).

Output

For each test case, output the answer in a single line. A relative error of 1e-8 will be accepted.

Sample Input

20 2 2 2 1 1 10 6 6 6 1 1 1

Sample Output

1.1428571428571431.004651162790698

http://acm.zju.edu.cn/onlinejudge/showProblem.do?problemId=3754

[cpp] view plain copy
 print?在CODE上查看代码片派生到我的代码片
  1. /*题意: 
  2. 有三个骰子,分别有k1,k2,k3个面。 
  3. 每次掷骰子,如果三个面分别为a,b,c则分数置0,否则加上三个骰子的分数之和。 
  4. 当分数大于n时结束。求游戏的期望步数。初始分数为0 
  5.  
  6. 分析: 
  7. 假设dp[i]表示拥有分数i到游戏结束的期望步数 
  8. 则  
  9. (1):dp[i]=SUM(p[k]*dp[i+k])+p[0]*dp[0]+1;//p[k]表示增加分数为k的概率,p[0]表示分数变为0的概率 
  10. 假定 
  11. (2):dp[i]=A[i]*dp[0]+B[i]; 
  12.  
  13. (3):dp[i+k]=A[i+k]*dp[0]+B[i+k]; 
  14. 将(3)代入(1)得: 
  15. (4):dp[i]=(SUM(p[k]*A[i+k])+p[0])*dp[0]+SUM(p[k]*B[i+k])+1; 
  16. 将4与2做比较得: 
  17. A[i]=(SUM(p[k]*A[i+k])+p[0]); 
  18. B[i]=SUM(p[k]*B[i+k])+1; 
  19. 当i+k>n时A[i+k]=B[i+k]=0可知 
  20. 所以dp[0]=B[0]/(1-A[0])可求出 
  21. ************************************************************************* 
  22. 总结下这类概率DP: 
  23. 既DP[i]可能由DP[i+k]和DP[i+j]需要求的比如DP[0]决定 
  24. 相当于概率一直递推下去会回到原点  
  25. 比如 
  26. (1):DP[i]=a*DP[i+k]+b*DP[0]+d*DP[i+j]+c;  
  27. 但是DP[i+k]和DP[0]都是未知 
  28. 这时候根据DP[i]的方程式假设一个方程式: 
  29. 比如: 
  30. (2):DP[i]=A[i]*DP[i+k]+B[i]*DP[0]+C[i]; 
  31. 因为要求DP[0],所以当i=0的时候但是A[0],B[0],C[0]未知 
  32. 对比(1)和(2)的差别  
  33. 这时候对比(1)和(2)发现两者之间的差别在于DP[i+j] 
  34. 所以根据(2)求DP[i+j]然后代入(1)消除然后对比(2)就可以得到A[i],B[i],C[i] 
  35. 然后视具体情况根据A[i],B[i],C[i]求得A[0],B[0],C[0]继而求DP[0]  
  36. 请看这题:http://acm.hdu.edu.cn/showproblem.php?pid=4035  
  37. ************************************************************************* 
  38. */  
  39. #include<iostream>
    #include<cstdio>
    #include<cstring>
    using namespace std;
    double p[20];
    double A[550];
    double B[550];
    int main(){


        int T,k1,k2,k3,a,b,c,n;
        scanf("%d",&T);
        while(T--){
            scanf("%d%d%d%d%d%d%d",&n,&k1,&k2,&k3,&a,&b,&c);
            memset(p,0,sizeof(p));
            memset(A,0,sizeof(A));
            memset(B,0,sizeof(B));
            p[0] = 1.0/k1/k2/k3;
            for(int i = 2; i <= k1; i++)
                for(int j = 2; j <= k2; j++)
                    for(int k = 2; k <= k3; k++)
                        if(i!=a || j!=b || k!=c)
                        p[i+j+k] += p[0];
            int total = k1+k2+k3;
            for(int i = n; i >= 0; i--){
                for(int k = 6; k <= total; k++){
                    A[i] += A[i+k]*p[k];
                    B[i] += B[i+k]*p[k];
                }
                B[i]+=1;
                A[i]+=p[0];
            }
            printf("%.9lf\n",B[0]/(1.0-A[0]));
        }


    }

0 0
原创粉丝点击